# OpenGl_tsm.h File Reference

`#include <OpenGl_cmn_varargs.h>`

## Defines

#define | G003
#define | OCC1188
#define | OCC2934

## Typedefs

typedef TSM_ELEM_DATA_UNION | TSM_ELEM_DATA
typedef TSM_ELEM_DATA_UNION * | tsm_elem_data
typedef TSM_ELEM_STRUCT | TSM_ELEM
typedef TSM_ELEM_STRUCT * | tsm_elem
typedef * | tsm_bg_texture
typedef TStatus(** | MtblPtr )(TSM_ELEM_DATA, Tint, cmn_key *)

## Enumerations

enum

TelType {
TelNil = 0, TelLabel, TelAntiAliasing, TelBlink,
TelExecuteStructure, TelTransformPersistence, TelPolylineColour, TelPolylineType,
TelPolylineWidth, TelInteriorStyle, TelInteriorColour, TelBackInteriorColour,
TelEdgeColour, TelEdgeType, TelEdgeWidth, TelEdgeFlag,
TelInteriorStyleIndex, TelFaceDistinguishingMode, TelFaceCullingMode, TelInteriorReflectanceEquation,
TelSurfaceAreaProperties, TelBackInteriorReflectanceEquation, TelBackSurfaceAreaProperties, TelPolymarkerColour,
TelPolymarkerType, TelPolymarkerSize, TelTextFont, TelTextHeight,
TelCharacterSpacing, TelCharacterExpansionFactor, TelTextColour, TelDepthCueIndex,
TelPickId, TelPolygon, TelPolygonSet, TelPolygonHoles,
TelPolygonIndices, TelQuadrangle, TelPolyline, TelMarker,
TelMarkerSet, TelText, TelTriangleMesh, TelAddNameset,
TelRemoveNameset, TelInteriorShadingMethod, TelLocalTran3, TelHighlightIndex,
TelLightSrcState, TelClippingPlane, TelViewIndex, TelApplicationData,
TelCurve, TelTextureId, TelDoTextureMap, TelTextStyle,
TelTextDisplayType, TelTextColourSubTitle, TelDegenerationMode, TelTextAlign,
TelParray, TelPolygonOffset, TelUserdraw, TelLast
}

enum | TSM_FillStyle { TSM_FS_CENTER, TSM_FS_TILE, TSM_FS_STRETCH }
enum | TMsgType { PickTraverse = 0, DisplayTraverse, Add, Delete, Print, Inquire }
enum | TEditMode { TEditInsert = 1, TEditReplace }

## Functions

void | TsmInitAllClasses (MtblPtr(**tbl)(TelType *), Tint size)
TEditMode | TsmSetEditMode (TEditMode)
TStatus | TsmSendMessage (TelType, TMsgType, TSM_ELEM_DATA, Tint,...)
TStatus | TsmOpenStructure (Tint)
TStatus | TsmCloseStructure (void)
TStatus | TsmDisplayStructure (Tint, Tint)
TStatus | TsmPrintStructure (Tint)
TStatus | TsmAddToStructure (TelType, Tint,...)
TStatus | TsmEmptyStructure (Tint)
TStatus | TsmDeleteStructure (Tint)
TStatus | TsmDeleteElement (void)
TStatus | TsmDeleteElementsBetweenLabels (Tint, Tint)
TStatus | TsmDeleteElementRange (Tint, Tint)
TStatus | TsmSetElementPointer (Tint)
TStatus | TsmSetElementPointerAtLabel (Tint)
TStatus | TsmSetElementPointerAtPickId (Tint)
TStatus | TsmOffsetElementPointer (Tint)
TStatus | TsmPickStructure (Tint)
TStatus | TsmGetStructure (Tint, Tint *, tsm_elem *)
TStatus | TsmGetStructureDepth (Tint, Tint *)
TStatus | TsmGetCurElem (TSM_ELEM *)
TStatus | TsmGetCurElemPtr (Tint *)

## Variables

Tint | TglActiveWs

## Define Documentation

#define G003

#define OCC1188

#define OCC2934

## Typedef Documentation

typedef TStatus(** MtblPtr)(TSM_ELEM_DATA, Tint, cmn_key *)

typedef * tsm_bg_texture

typedef struct TSM_ELEM_STRUCT * tsm_elem

typedef struct TSM_ELEM_STRUCT TSM_ELEM

typedef union TSM_ELEM_DATA_UNION * tsm_elem_data

typedef union TSM_ELEM_DATA_UNION TSM_ELEM_DATA

## Enumeration Type Documentation

enum TEditMode

Enumeration values:

  TEditInsert |
  TEditReplace |

enum TelType

Enumeration values:

  TelNil |
  TelLabel |
  TelAntiAliasing |
  TelBlink |
  TelExecuteStructure |
  TelTransformPersistence |
  TelPolylineColour |
  TelPolylineType |
  TelPolylineWidth |
  TelInteriorStyle |
  TelInteriorColour |
  TelBackInteriorColour |
  TelEdgeColour |
  TelEdgeType |
  TelEdgeWidth |
  TelEdgeFlag |
  TelInteriorStyleIndex |
  TelFaceDistinguishingMode |
  TelFaceCullingMode |
  TelInteriorReflectanceEquation |
  TelSurfaceAreaProperties |
  TelBackInteriorReflectanceEquation |
  TelBackSurfaceAreaProperties |
  TelPolymarkerColour |
  TelPolymarkerType |
  TelPolymarkerSize |
  TelTextFont |
  TelTextHeight |
  TelCharacterSpacing |
  TelCharacterExpansionFactor |
  TelTextColour |
  TelDepthCueIndex |
  TelPickId |
  TelPolygon |
  TelPolygonSet |
  TelPolygonHoles |
  TelPolygonIndices |
  TelQuadrangle |
  TelPolyline |
  TelMarker |
  TelMarkerSet |
  TelText |
  TelTriangleMesh |
  TelAddNameset |
  TelRemoveNameset |
  TelInteriorShadingMethod |
  TelLocalTran3 |
  TelHighlightIndex |
  TelLightSrcState |
  TelClippingPlane |
  TelViewIndex |
  TelApplicationData |
  TelCurve |
  TelTextureId |
  TelDoTextureMap |
  TelTextStyle |
  TelTextDisplayType |
  TelTextColourSubTitle |
  TelDegenerationMode |
  TelTextAlign |
  TelParray |
  TelPolygonOffset |
  TelUserdraw |
  TelLast |

enum TMsgType

Enumeration values:

  PickTraverse |
  DisplayTraverse |
  Add |
  Delete |
  Print |
  Inquire |

enum TSM_FillStyle

Enumeration values:

  TSM_FS_CENTER |
  TSM_FS_TILE |
  TSM_FS_STRETCH |

## Function Documentation

TStatus TsmAddToStructure | ( | TelType | ,
|  | Tint | ,
|  |  | ...
| ) |

TStatus TsmCloseStructure | ( | void |  | ) |

TStatus TsmDeleteElement | ( | void |  | ) |

TStatus TsmDeleteElementRange | ( | Tint | ,
|  | Tint |
| ) |

TStatus TsmDeleteElementsBetweenLabels | ( | Tint | ,
|  | Tint |
| ) |

TStatus TsmDeleteStructure | ( | Tint |  | ) |

TStatus TsmDisplayStructure | ( | Tint | ,
|  | Tint |
| ) |

TStatus TsmEmptyStructure | ( | Tint |  | ) |

TStatus TsmGetCurElem | ( | TSM_ELEM * |  | ) |

TStatus TsmGetCurElemPtr | ( | Tint * |  | ) |

TStatus TsmGetStructure | ( | Tint | ,
|  | Tint * | ,
|  | tsm_elem * |
| ) |

TStatus TsmGetStructureDepth | ( | Tint | ,
|  | Tint * |
| ) |

void TsmInitAllClasses | ( | MtblPtr(**)(TelType *) | tbl,
|  | Tint | size
| ) |

TStatus TsmOffsetElementPointer | ( | Tint |  | ) |

TStatus TsmOpenStructure | ( | Tint |  | ) |

TStatus TsmPickStructure | ( | Tint |  | ) |

TStatus TsmPrintStructure | ( | Tint |  | ) |

TStatus TsmSendMessage | ( | TelType | ,
|  | TMsgType | ,
|  | TSM_ELEM_DATA | ,
|  | Tint | ,
|  |  | ...
| ) |

TEditMode TsmSetEditMode | ( | TEditMode |  | ) |

TStatus TsmSetElementPointer | ( | Tint |  | ) |

TStatus TsmSetElementPointerAtLabel | ( | Tint |  | ) |

TStatus TsmSetElementPointerAtPickId | ( | Tint |  | ) |

## Variable Documentation

Tint TglActiveWs